use 5.006;
use inc::Module::Install;
# See lib/ExtUtils/MakeMaker.pm for details of how to influence
# the contents of the Makefile that is written.

my $version = '0.04';
my $name    = 'parselog-cgi';
my $fname   = "parselog-cgi-$version";
my $cgidir  = get_cgi_dir();
my $cgiuser = get_cgi_user();

my $prereqs = {
    'RRDs'             => 0,
    'DateTime'         => 0,
    'NCGI'             => 0.03,
    'debug'            => 0,
};

sub MY::postamble { "

CGIBINDIR = $cgidir
CGIUSER   = $cgiuser

changes:
	echo 'Changelog for $name' > $$
	echo '' >> $$
	-darcs changes >> $$ && mv $$ Changes
	rm -f $$

deb: changes
	(head -1 debian/changelog | grep $version) || exit 1
	rm -f $fname.tar.gz
	-chmod 755 debian/rules
	\$(MAKE) dist
	tar zxvf $fname.tar.gz
	cd $fname && dpkg-buildpackage -b -rfakeroot -tc

deba:
	sudo cp *.deb *.changes /var/lib/debarchiver/incoming
	sudo debarchiver -so

tgz:
	rm -f $name.tgz
	ln -s $fname.tar.gz $name.tgz

dirs:
	-mkdir -p \$(DESTDIR)/var/cache/parselog-cgi
	-mkdir -p \$(DESTDIR)/etc/parselog/css
	-chown \$(CGIUSER) \$(DESTDIR)/var/cache/parselog-cgi

cgi: dirs
	-mkdir -p \$(DESTDIR)\$(CGIBINDIR)
	install -m 755 bin/parselog.cgi \$(DESTDIR)\$(CGIBINDIR)
#	\$(PERLRUN) \"-MExtUtils::MY\" -e \"MY->fixin(shift)\" \$(DESTDIR)\$(CGIBINDIR)/parselog.cgi
	-mkdir -p \$(DESTDIR)/etc/parselog
	if [ ! -s \$(DESTDIR)/etc/parselog/parselog-cgi.conf ]; then \\
		install -m 644 conf/parselog-cgi.conf \$(DESTDIR)/etc/parselog; \\
	fi
	if [ ! -s \$(DESTDIR)/etc/parselog/css/style.css ]; then \\
		install -m 644 conf/style.css \$(DESTDIR)/etc/parselog/css; \\
	fi

apache:
	-mkdir -p \$(DESTDIR)/etc/apache/conf.d
	install -m 644 conf/apache.conf \\
    	\$(DESTDIR)/etc/apache/conf.d/parselog-cgi.conf

apache2:
	-mkdir -p \$(DESTDIR)/etc/apache2/conf.d
	install -m 644 conf/apache.conf \\
	    \$(DESTDIR)/etc/apache2/conf.d/parselog-cgi.conf

";
}

WriteMakefile(
    NAME              => $name,
    VERSION           => $version,
    PREREQ_PM         => $prereqs,
    ABSTRACT          => 'Generate graphs from parselog data',
    AUTHOR            => 'Mark Lawrence <nomad@null.net>',
    EXE_FILES         => ['bin/parselog.cgi'],
);



sub get_cgi_dir {

    my $dir = $ENV{'CGIBINDIR'} || "/usr/lib/cgi-bin";

    if ( lc((uname)[0]) eq "freebsd" and -d "/usr/local/www/cgi-bin") {
        $dir = "/usr/local/www/cgi-bin";
    }
    elsif ( lc((uname)[0]) eq "darwin" and -d "/Library/WebServer/CGI-Executables") {
        $dir = "/Library/WebServer/CGI-Executables";
    }
    elsif (-d "/usr/local/apache/cgi-bin") {
        $dir = "/usr/local/apache/cgi-bin";
    }

    return $dir;
}

sub get_cgi_user {

    my $user = 'www-data.www-data';
    return $user;

    if ( lc((uname)[0]) eq "freebsd" and -d "/usr/local/www/cgi-bin") {
        $dir = "/usr/local/www/cgi-bin";
    }
    elsif ( lc((uname)[0]) eq "darwin" and -d "/Library/WebServer/CGI-Executables") {
        $dir = "/Library/WebServer/CGI-Executables";
    }
    elsif (-d "/usr/local/apache/cgi-bin") {
        $dir = "/usr/local/apache/cgi-bin";
    }

    return $dir;
}

